from System.Collections.Generic import List
from System import Byte, Int32
import sys
import time
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    textParts = ["Charges:", "Max Charges:", "Rename book", "Drop rune", 
                 "Set default", "Recall", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    index = index + 2
    #Misc.SendMessage("Starts at: {}".format(index))
    return index

#
def StoreItems():
    if Misc.CheckSharedValue("BagOfHolding"):
        BOH = Misc.ReadSharedValue("BagOfHolding") 
        ItemList = [ 0x0F3F, 0x1BD4, 0x1BD1 ] 
        for itemId in ItemList:  
            item = Items.FindByID(itemId, -1, Player.Backpack.Serial)
            if item is not None:
                Items.Move(item, BOH, 0)
                Misc.Pause(1000)
    
    
def main():
    #
    # First keep track of position in book 
    #
    RuneBooks = [0x40611174]
    RuneBookIndex = 0
    RuneBookIndexName = "Arrow RuneBook Order"
    if Misc.CheckSharedValue(RuneBookIndexName):
        RuneBookIndex = Misc.ReadSharedValue(RuneBookIndexName)
    #    
    #
    #
    # Next keep track of position in book. At end of a book we'll set next book 
    #
    RuneOrder = [ 5, 11, 17, 23, 29, 35, 41, 47, 53, 59, 65, 71, 77, 83, 95 ] 
    #
    # First set which rune to use to 0 in case its not stored yet
    # if its stored we'll use the stored value 
    RuneIndex = 0
    RuneIndexName = "Arrow Rune Order"
    if Misc.CheckSharedValue(RuneIndexName):
            RuneIndex = Misc.ReadSharedValue(RuneIndexName)       
    #    
    # Now store whatever it is +1 so next time we'll do the next one
    new_rune_index = RuneIndex+1
    # check if the new index is past the end, then start back at 0
    if new_rune_index >= len(RuneOrder):
        new_rune_index = 0
        # and move to the next book
        new_book_index = RuneBookIndex+1
        # check if the new book index is past the end, then start back at 0
        # Maybe want to stop here, because probably chests have not respawned
        if new_book_index >= len(RuneBooks):
            new_book_index = 0
        Misc.SetSharedValue(RuneBookIndexName, new_book_index)
        Player.HeadMessage(54, "Stopping") 
        Misc.SetSharedValue(RuneIndexName, new_rune_index)
        return False
    # Now store the next rune so that next time we come here we start with the new one
    Misc.SetSharedValue(RuneIndexName, new_rune_index)
    #
    #
    # Now finally everything is set. 
    #
    #
    # RuneBookIndex is set to the current book to use
    # RuneIndex is set to which rune in that book to use
    Gumps.ResetGump()
    Items.UseItem(RuneBooks[RuneBookIndex])
    Gumps.WaitForGump(Gumps.CurrentGump(), 10000)
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
    Misc.SendMessage(bookSlotName.strip().lower()) 
    if bookSlotName.strip().lower() != "empty":
        Gumps.SendAction(Gumps.CurrentGump(), RuneOrder[RuneIndex])
        Misc.Pause(2000)
        Misc.Resync()
        Misc.Pause(3000)
        Vendor_ids = [(0x0000473A), 
                      (0x00000DFF),
                      (0x000046F4),
                      (0x000052AC),
                      (0x00003386),
                      (0x00003666),
                      (0x00003904),
                      (0x0000454C),
                      (0x00004560), #9
                      (0x0000330E),
                      (0x000035C4),
                      (0x00003FA7),
                      (0x000032BD),
                      (0x000040AE),
                      (0x00007C20),
                      (0x00003EFB),
                      ]
                      
                      #(0x00004FE4, 1),
                      
        if RuneIndex < len(Vendor_ids):              
            vendor = Mobiles.FindBySerial(Vendor_ids[RuneIndex])
            #Player.HeadMessage(55, "0x{:x}".format(Vendor_ids[RuneIndex]))
            Misc.WaitForContext(Vendor_ids[RuneIndex], 10000)
            Misc.ContextReply(Vendor_ids[RuneIndex], "buy")
            Misc.Pause(5000)
            StoreItems()
            Misc.Pause(5000)
            return True        
        else:            
            Misc.SendMessage("No Vendor associated with this index {}".format(RuneIndex))
    else:
        Misc.SendMessage("Skipping recall slot {} because it is empty".format(RuneIndex))
    return False

#
def convert(seconds): 
    seconds = seconds % (24 * 3600) 
    hour = seconds // 3600
    seconds %= 3600
    minutes = seconds // 60
    seconds %= 60
      
    return hour, minutes, seconds

#    
while True:
    if Misc.CheckSharedValue("VendorBuyTime"):
        nextBuyTime = Misc.ReadSharedValue("VendorBuyTime")
    else:
        nextBuyTime = time.time()
    #nextBuyTime = 0    
    delay = int(nextBuyTime - time.time())
    if delay > 0:
       hours, minutes, seconds = convert(delay) 
       Player.HeadMessage(50, "Delaying for {} minutes and {} seconds".format(minutes, seconds)) 
       Misc.Pause(1000 * delay) 
    #
    BuyAgent.Enable()
    more = True 
    while more:
        if len(Player.Backpack.Contains) < 150:
            more = main()
        else:
            sys.exit(99)
    Misc.SetSharedValue("VendorBuyTime", time.time()+(31*60))                    
    #BuyAgent.Disable()
#        
        
